//--------------------------------------------------------------
// Press F1 to get help about using script.
// To access an object that is not located in the current class, start the call with Globals.
// When using events and timers be cautious not to generate memoryleaks,
// please see the help for more information.
//---------------------------------------------------------------

namespace Neo.ApplicationFramework.Generated
{
    using System.Windows.Forms;
    using System;
    using System.Drawing;
    using Neo.ApplicationFramework.Tools;
    using Neo.ApplicationFramework.Common.Graphics.Logic;
    using Neo.ApplicationFramework.Controls;
    using Neo.ApplicationFramework.Interfaces;
	//Added
	using System.Runtime.InteropServices;
    
    public partial class ScriptModule1
    {
		//Set's local time
		[DllImport("coredll.dll", EntryPoint="SetLocalTime", SetLastError = true)]
		static extern bool SetLocalTime(ref SystemTime st);
	
		public struct SystemTime
		{
			public ushort Year;
			public ushort Month;
			public ushort DayOfWeek;
			public ushort Day;
			public ushort Hour;
			public ushort Minute;
			public ushort Second;
			public ushort Millisecond;
		};

		public void update_DateTime()
		{
			try
			{
				SystemTime st = new SystemTime();
				
				st.Year           = Globals.Tags.Tag_Year.Value;
				st.Month    = Globals.Tags.Tag_Month.Value;
				st.Day            = Globals.Tags.Tag_Day.Value;
				st.DayOfWeek= Globals.Tags.Tag_DayOfWeek.Value;
				st.Hour           = Convert.ToUInt16
					(Globals.Tags.Tag_Hour.Value % 24);
				st.Minute   = Globals.Tags.Tag_Minute.Value;
				st.Second   = Globals.Tags.Tag_Second.Value;
				st.Millisecond    =
					Globals.Tags.Tag_Millisecond.Value;
				
				bool result = SetLocalTime(ref st);
				if (true != result)
				{
					int error = Marshal.GetLastWin32Error();
					MessageBox.Show(String.Format("SetSystemTime failed: {0:X8}", error));
				}
			}
			catch (Exception x)
			{
				MessageBox.Show(x.Message);
			}
		}
    }
}
